/[gentoo-x86]/eclass/vdr-plugin.eclass
Gentoo

Diff of /eclass/vdr-plugin.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.64 Revision 1.73
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2005 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.64 2008/06/25 21:35:27 zzam Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.73 2011/03/13 19:06:26 hd_brummy Exp $
4# 4#
5# Author: 5# Author:
6# Matthias Schwarzott <zzam@gentoo.org> 6# Matthias Schwarzott <zzam@gentoo.org>
7# Joerg Bornkessel <hd_brummy@gentoo.org> 7# Joerg Bornkessel <hd_brummy@gentoo.org>
8 8
9# vdr-plugin.eclass 9# vdr-plugin.eclass
10# 10#
11# eclass to create ebuilds for vdr plugins 11# eclass to create ebuilds for vdr plugins
12# 12#
13 13
14# Example ebuild (vdr-femon): 14# Example ebuild (basic version without patching):
15# 15#
16# EAPI="2"
16# inherit vdr-plugin 17# inherit vdr-plugin
17# IUSE="" 18# IUSE=""
18# SLOT="0" 19# SLOT="0"
19# DESCRIPTION="vdr Plugin: DVB Frontend Status Monitor (signal strengt/noise)" 20# DESCRIPTION="vdr Plugin: DVB Frontend Status Monitor (signal strengt/noise)"
20# HOMEPAGE="http://www.saunalahti.fi/~rahrenbe/vdr/femon/" 21# HOMEPAGE="http://www.saunalahti.fi/~rahrenbe/vdr/femon/"
21# SRC_URI="http://www.saunalahti.fi/~rahrenbe/vdr/femon/files/${P}.tgz" 22# SRC_URI="http://www.saunalahti.fi/~rahrenbe/vdr/femon/files/${P}.tgz"
22# LICENSE="GPL-2" 23# LICENSE="GPL-2"
23# KEYWORDS="~x86" 24# KEYWORDS="~x86"
24# DEPEND=">=media-video/vdr-1.3.27" 25# DEPEND=">=media-video/vdr-1.6.0"
25# 26#
26# 27#
28
29# For patching you should modify src_prepare phase:
30#
31# src_prepare() {
32# epatch "${FILESDIR}"/${P}-xxx.patch
33# vdr-plugin_src_prepare
34# }
27 35
28# Installation of a config file for the plugin 36# Installation of a config file for the plugin
29# 37#
30# If ${VDR_CONFD_FILE} is set install this file 38# If ${VDR_CONFD_FILE} is set install this file
31# else install ${FILESDIR}/confd if it exists. 39# else install ${FILESDIR}/confd if it exists.
57# 65#
58# all patches which ending on diff or patch in this DIR will automatically applied 66# all patches which ending on diff or patch in this DIR will automatically applied
59# 67#
60 68
61inherit base multilib eutils flag-o-matic 69inherit base multilib eutils flag-o-matic
70
71if ! has "${EAPI:-0}" 0 1 2 3; then
72 die "API of vdr-plugin.eclass in EAPI=\"${EAPI}\" not established"
73fi
62 74
63IUSE="" 75IUSE=""
64 76
65# Name of the plugin stripped from all vdrplugin-, vdr- and -cvs pre- and postfixes 77# Name of the plugin stripped from all vdrplugin-, vdr- and -cvs pre- and postfixes
66VDRPLUGIN="${PN/#vdrplugin-/}" 78VDRPLUGIN="${PN/#vdrplugin-/}"
71 83
72# works in most cases 84# works in most cases
73S="${WORKDIR}/${VDRPLUGIN}-${PV}" 85S="${WORKDIR}/${VDRPLUGIN}-${PV}"
74 86
75# depend on headers for DVB-driver 87# depend on headers for DVB-driver
76DEPEND=">=media-tv/gentoo-vdr-scripts-0.3.8 88COMMON_DEPEND=">=media-tv/gentoo-vdr-scripts-0.4.2"
77 || ( >=media-tv/gentoo-vdr-scripts-0.4.2 >=media-tv/vdrplugin-rebuild-0.2 ) 89
78 >=app-admin/eselect-vdr-0.0.2 90DEPEND="${COMMON_DEPEND}
79 media-tv/linuxtv-dvb-headers" 91 media-tv/linuxtv-dvb-headers"
92RDEPEND="${COMMON_DEPEND}
93 >=app-admin/eselect-vdr-0.0.2"
80 94
95# this is a hack for ebuilds like vdr-xineliboutput that want to
96# conditionally install a vdr-plugin
97if [[ "${GENTOO_VDR_CONDITIONAL:-no}" = "yes" ]]; then
98 # make DEPEND conditional
99 IUSE="${IUSE} vdr"
100 DEPEND="vdr? ( ${DEPEND} )"
101 RDEPEND="vdr? ( ${RDEPEND} )"
102fi
81 103
82# New method of storing plugindb 104# New method of storing plugindb
83# Called from src_install 105# Called from src_install
84# file maintained by normal portage-methods 106# file maintained by normal portage-methods
85create_plugindb_file() { 107create_plugindb_file() {
153 done 175 done
154} 176}
155 177
156fix_vdr_libsi_include() 178fix_vdr_libsi_include()
157{ 179{
158 einfo "Fixing include of libsi-headers" 180 #einfo "Fixing include of libsi-headers"
159 local f 181 local f
160 for f; do 182 for f; do
161 sed -i "${f}" \ 183 sed -i "${f}" \
162 -e '/#include/s:"\(.*libsi.*\)":<\1>:' \ 184 -e '/#include/s:"\(.*libsi.*\)":<\1>:' \
163 -e '/#include/s:<.*\(libsi/.*\)>:<vdr/\1>:' 185 -e '/#include/s:<.*\(libsi/.*\)>:<vdr/\1>:'
183 # To satisfy 1-3 we do this: 205 # To satisfy 1-3 we do this:
184 # Set VDRDIR=/usr/include/vdr 206 # Set VDRDIR=/usr/include/vdr
185 # Set VDRINCDIR=/usr/include 207 # Set VDRINCDIR=/usr/include
186 # Change $(VDRDIR)/include to $(VDRINCDIR) 208 # Change $(VDRDIR)/include to $(VDRINCDIR)
187 209
188 ebegin " Setting paths"
189 sed -i Makefile \ 210 sed -i Makefile \
190 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \ 211 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \
191 -e "/^VDRDIR/a VDRINCDIR = ${VDR_INCLUDE_DIR%/vdr}" \ 212 -e "/^VDRDIR/a VDRINCDIR = ${VDR_INCLUDE_DIR%/vdr}" \
192 -e '/VDRINCDIR.*=/!s:$(VDRDIR)/include:$(VDRINCDIR):' \ 213 -e '/VDRINCDIR.*=/!s:$(VDRDIR)/include:$(VDRINCDIR):' \
193 \ 214 \
194 -e 's:-I$(DVBDIR)/include::' \ 215 -e 's:-I$(DVBDIR)/include::' \
195 -e 's:-I$(DVBDIR)::' 216 -e 's:-I$(DVBDIR)::'
196 eend 0
197 217
198 # maybe needed for multiproto: 218 # maybe needed for multiproto:
199 #sed -i Makefile \ 219 #sed -i Makefile \
200 # -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \ 220 # -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
201 # -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' 221 # -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):'
217 237
218 # Disabling file stripping, useful for debugging 238 # Disabling file stripping, useful for debugging
219 sed -i Makefile \ 239 sed -i Makefile \
220 -e '/@.*strip/d' \ 240 -e '/@.*strip/d' \
221 -e '/strip \$(LIBDIR)\/\$@/d' \ 241 -e '/strip \$(LIBDIR)\/\$@/d' \
222 -e '/@.*\$(STRIP)/d' 242 -e 's/STRIP.*=.*$/STRIP = true/'
223 243
224 # Use a file instead of a variable as single-stepping via ebuild 244 # Use a file instead of a variable as single-stepping via ebuild
225 # destroys environment. 245 # destroys environment.
226 touch "${WORKDIR}"/.vdr-plugin_makefile_patched 246 touch "${WORKDIR}"/.vdr-plugin_makefile_patched
227} 247}
283 return 1 303 return 1
284 fi 304 fi
285} 305}
286 306
287vdr_i18n_disable_gettext() { 307vdr_i18n_disable_gettext() {
288 ebegin "Disabling gettext support in plugin" 308 #einfo "Disabling gettext support in plugin"
309
289 # Remove i18n Target if using older vdr 310 # Remove i18n Target if using older vdr
290 sed -i Makefile \ 311 sed -i Makefile \
291 -e '/^all:/s/ i18n//' 312 -e '/^all:/s/ i18n//'
292 eend 0
293} 313}
294 314
295vdr_i18n() { 315vdr_i18n() {
296 if vdr_has_gettext; then 316 if vdr_has_gettext; then
297 einfo "VDR has gettext support" 317 #einfo "VDR has gettext support"
298 if plugin_has_gettext; then 318 if plugin_has_gettext; then
299 einfo "Plugin has gettext support, fine" 319 #einfo "Plugin has gettext support, fine"
300 if [[ ${NO_GETTEXT_HACK} == "1" ]]; then 320 if [[ ${NO_GETTEXT_HACK} == "1" ]]; then
301 ewarn "Please remove left over NO_GETTEXT_HACK." 321 ewarn "Please remove unneeded NO_GETTEXT_HACK from ebuild."
302 fi 322 fi
303 else 323 else
304 vdr_i18n_convert_to_gettext 324 vdr_i18n_convert_to_gettext
305 if [[ $? != 0 ]]; then 325 if [[ $? != 0 ]]; then
306 eerror "" 326 eerror ""
307 eerror "Plugin will have only english OSD texts" 327 eerror "Plugin will have only english OSD texts"
308 eerror "it needs manual fixing." 328 eerror "it needs manual fixing."
309 fi 329 fi
310 fi 330 fi
311 else 331 else
312 einfo "VDR has no gettext support" 332 #einfo "VDR has no gettext support"
313 if plugin_has_gettext; then 333 if plugin_has_gettext; then
314 vdr_i18n_disable_gettext 334 vdr_i18n_disable_gettext
315 fi 335 fi
316 fi 336 fi
317} 337}
354 elog "To activate a plugin execute this command:" 374 elog "To activate a plugin execute this command:"
355 elog "\teselect vdr-plugin enable <plugin_name> ..." 375 elog "\teselect vdr-plugin enable <plugin_name> ..."
356 elog 376 elog
357} 377}
358 378
379has_vdr() {
380 [[ -f "${VDR_INCLUDE_DIR}"/config.h ]]
381}
359 382
360## exported functions 383## exported functions
361 384
362vdr-plugin_pkg_setup() { 385vdr-plugin_pkg_setup() {
363 # -fPIC is needed for shared objects on some platforms (amd64 and others) 386 # -fPIC is needed for shared objects on some platforms (amd64 and others)
364 append-flags -fPIC 387 append-flags -fPIC
365 388
389 # Plugins need to be compiled with position independent code, otherwise linking
390 # VDR against it will fail
391 if has_version ">=media-video/vdr-1.7.13"; then
392 append-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
393 fi
394
366 # Where should the plugins live in the filesystem 395 # Where should the plugins live in the filesystem
367 VDR_PLUGIN_DIR="/usr/$(get_libdir)/vdr/plugins" 396 VDR_PLUGIN_DIR="/usr/$(get_libdir)/vdr/plugins"
368 VDR_CHECKSUM_DIR="${VDR_PLUGIN_DIR%/plugins}/checksums" 397 VDR_CHECKSUM_DIR="${VDR_PLUGIN_DIR%/plugins}/checksums"
369 398
370 # was /usr/lib/... some time ago 399 # was /usr/lib/... some time ago
374 # Pathes to includes 403 # Pathes to includes
375 VDR_INCLUDE_DIR="/usr/include/vdr" 404 VDR_INCLUDE_DIR="/usr/include/vdr"
376 DVB_INCLUDE_DIR="/usr/include" 405 DVB_INCLUDE_DIR="/usr/include"
377 406
378 TMP_LOCALE_DIR="${WORKDIR}/tmp-locale" 407 TMP_LOCALE_DIR="${WORKDIR}/tmp-locale"
408 if has_version ">=media-video/vdr-1.7.17"; then
409 LOCDIR="/usr/share/locale"
410 else
379 LOCDIR="/usr/share/vdr/locale" 411 LOCDIR="/usr/share/vdr/locale"
412 fi
413
414 if ! has_vdr; then
415 # set to invalid values to detect abuses
416 VDRVERSION="eclass_no_vdr_installed"
417 APIVERSION="eclass_no_vdr_installed"
418
419 if [[ "${GENTOO_VDR_CONDITIONAL:-no}" = "yes" ]] && ! use vdr; then
420 einfo "VDR not found!"
421 else
422 # if vdr is required
423 die "VDR not found!"
424 fi
425 return
426 fi
380 427
381 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h) 428 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
382 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h) 429 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
383 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}" 430 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}"
384 431
385 einfo "Compiling against" 432 einfo "Compiling against"
386 einfo "\tvdr-${VDRVERSION} [API version ${APIVERSION}]" 433 einfo "\tvdr-${VDRVERSION} [API version ${APIVERSION}]"
434}
435
436vdr-plugin_src_util() {
437
438 while [ "$1" ]; do
439
440 case "$1" in
441 all)
442 vdr-plugin_src_util unpack add_local_patch patchmakefile i18n
443 ;;
444 prepare|all_but_unpack)
445 vdr-plugin_src_util add_local_patch patchmakefile i18n
446 ;;
447 unpack)
448 base_src_unpack
449 ;;
450 add_local_patch)
451 cd "${S}" || die "Could not change to plugin-source-directory!"
452 vdr_add_local_patch
453 ;;
454 patchmakefile)
455 cd "${S}" || die "Could not change to plugin-source-directory!"
456 vdr_patchmakefile
457 ;;
458 i18n)
459 cd "${S}" || die "Could not change to plugin-source-directory!"
460 vdr_i18n
461 ;;
462 esac
463
464 shift
465 done
387} 466}
388 467
389vdr-plugin_src_unpack() { 468vdr-plugin_src_unpack() {
390 if [[ -z ${VDR_INCLUDE_DIR} ]]; then 469 if [[ -z ${VDR_INCLUDE_DIR} ]]; then
391 eerror "Wrong use of vdr-plugin.eclass." 470 eerror "Wrong use of vdr-plugin.eclass."
392 eerror "An ebuild for a vdr-plugin will not work without calling vdr-plugin_pkg_setup." 471 eerror "An ebuild for a vdr-plugin will not work without calling vdr-plugin_pkg_setup."
393 echo 472 echo
394 eerror "Please report this at bugs.gentoo.org." 473 eerror "Please report this at bugs.gentoo.org."
395 die "vdr-plugin_pkg_setup not called!" 474 die "vdr-plugin_pkg_setup not called!"
396 fi 475 fi
397 [ -z "$1" ] && vdr-plugin_src_unpack unpack add_local_patch patchmakefile i18n 476 if [ -z "$1" ]; then
477 case "${EAPI:-0}" in
478 2|3)
479 vdr-plugin_src_util unpack
480 ;;
481 *)
482 vdr-plugin_src_util all
483 ;;
484 esac
485
486 else
487 vdr-plugin_src_util $@
488 fi
489}
490
491vdr-plugin_src_prepare() {
492 base_src_prepare
493 vdr-plugin_src_util prepare
494}
495
496vdr-plugin_src_compile() {
497 [ -z "$1" ] && vdr-plugin_src_compile copy_source compile
398 498
399 while [ "$1" ]; do 499 while [ "$1" ]; do
400 500
401 case "$1" in 501 case "$1" in
402 all_but_unpack) 502 copy_source)
403 vdr-plugin_src_unpack add_local_patch patchmakefile i18n
404 ;;
405 unpack)
406 base_src_unpack
407 ;;
408 add_local_patch)
409 cd "${S}" || die "Could not change to plugin-source-directory!"
410 vdr_add_local_patch
411 ;;
412 patchmakefile)
413 cd "${S}" || die "Could not change to plugin-source-directory!"
414 vdr_patchmakefile
415 ;;
416 i18n)
417 cd "${S}" || die "Could not change to plugin-source-directory!"
418 vdr_i18n
419 ;;
420 esac
421
422 shift
423 done
424}
425
426vdr-plugin_src_compile() {
427 [ -z "$1" ] && vdr-plugin_src_compile prepare compile
428
429 while [ "$1" ]; do
430
431 case "$1" in
432 prepare)
433 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_copy_source_tree 503 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_copy_source_tree
434 ;; 504 ;;
435 compile) 505 compile)
436 if [[ ! -f ${WORKDIR}/.vdr-plugin_makefile_patched ]]; then 506 if [[ ! -f ${WORKDIR}/.vdr-plugin_makefile_patched ]]; then
437 eerror "Wrong use of vdr-plugin.eclass." 507 eerror "Wrong use of vdr-plugin.eclass."
441 eerror "Please report this at bugs.gentoo.org." 511 eerror "Please report this at bugs.gentoo.org."
442 die "vdr-plugin_src_unpack not called!" 512 die "vdr-plugin_src_unpack not called!"
443 fi 513 fi
444 cd "${S}" 514 cd "${S}"
445 515
516 BUILD_TARGETS=${BUILD_TARGETS:-${VDRPLUGIN_MAKE_TARGET:-all}}
517
446 emake ${BUILD_PARAMS} \ 518 emake ${BUILD_PARAMS} \
447 ${VDRPLUGIN_MAKE_TARGET:-all} \ 519 ${BUILD_TARGETS} \
448 LOCALEDIR="${TMP_LOCALE_DIR}" \ 520 LOCALEDIR="${TMP_LOCALE_DIR}" \
449 LIBDIR="${S}" \ 521 LIBDIR="${S}" \
450 TMPDIR="${T}" \ 522 TMPDIR="${T}" \
451 || die "emake failed" 523 || die "emake failed"
452 ;; 524 ;;
543vdr-plugin_pkg_config() { 615vdr-plugin_pkg_config() {
544 ewarn "emerge --config ${PN} is no longer supported" 616 ewarn "emerge --config ${PN} is no longer supported"
545 vdr-plugin_print_enable_command 617 vdr-plugin_print_enable_command
546} 618}
547 619
620case "${EAPI:-0}" in
621 2|3)
622 EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_compile src_install pkg_postinst pkg_postrm pkg_config
623 ;;
624 *)
548EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_postrm pkg_config 625 EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_postrm pkg_config
626 ;;
627esac

Legend:
Removed from v.1.64  
changed lines
  Added in v.1.73

  ViewVC Help
Powered by ViewVC 1.1.20